<template>
  <div class="referInfo">
    <!-- 测试 -->
    <el-form
      ref="referRef"
      :model="referForm"
      label-position="top"
      class="checkForm"
      :rules="referInfoRules"
    >
      <div class="cont_title">个人信息</div>
      <el-row :gutter="20">
        <!-- 姓名 -->
        <el-col :span="12" v-show="configJson.name == 1">
          <el-form-item
            label="姓名"
            prop="name"
            style="height: 73px"
            :rules="
              configJson.name == 1 ? referInfoRules.name : [{ required: false }]
            "
          >
            <el-input
              ref="name"
              v-model="referForm.name"
              placeholder="填写真实姓名"
              size="small"
              clearable
            />
          </el-form-item>
        </el-col>
        <!-- 性别 -->
        <el-col :span="12" v-show="configJson.gender == 1">
          <el-form-item
            label="性别"
            prop="gender"
            style="height: 73px"
            :rules="
              configJson.gender == 1
                ? referInfoRules.gender
                : [{ required: false }]
            "
          >
            <el-radio-group
              v-model="referForm.gender"
              ref="gender"
              size="small"
            >
              <el-radio :label="0">男</el-radio>
              <el-radio :label="1">女</el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
        <!-- 年龄 -->
        <el-col :span="12" v-show="configJson.age == 1">
          <el-form-item
            label="年龄"
            prop="age"
            style="height: 73px"
            :rules="
              configJson.age == 1 ? referInfoRules.age : [{ required: false }]
            "
          >
            <el-input
              ref="age"
              v-model="referForm.age"
              placeholder="填写年龄"
              size="small"
              clearable
            />
          </el-form-item>
        </el-col>

        <el-col :span="12" v-show="configJson.country == 1">
          <el-form-item
            label="国籍"
            prop="country"
            :rules="
              configJson.country == 1
                ? referInfoRules.country
                : [{ required: false }]
            "
            style="height: 73px"
          >
            <el-select
              v-model="referForm.country"
              placeholder="国籍"
              :popper-append-to-body="false"
              filterable
            >
              <el-option
                v-for="(item, index) in countryList"
                :key="index"
                :label="item.label"
                :value="item.label"
              >
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <!-- <el-col :span="12">
          <el-form-item label="入学年份" prop="start_school_date">
            <el-row :gutter="20"> -->
        <!-- <el-col :span="12">
                <el-select
                  v-model="start_grade"
                  placeholder="年级"
                  :popper-append-to-body="false"
                  clearable
                >
                  <el-option
                    v-for="(item, index) in gradeArrs"
                    :key="index"
                    :label="item"
                    :value="item"
                  >
                  </el-option>
                </el-select>
              </el-col> -->
        <!-- <el-col :span="24">
                <el-select
                  ref="start_school_date"
                  v-model="start_year"
                  placeholder="年份"
                  clearable
                  :popper-append-to-body="false"
                  @change="getyear()"
                >
                  <el-option
                    v-for="(item, index) in yearArrs"
                    :key="index"
                    :label="item"
                    :value="item"
                  >
                  </el-option>
                </el-select>
              </el-col>
            </el-row>
          </el-form-item>
        </el-col> -->
        <!-- 身份证号 -->
        <el-col :span="12" v-show="configJson.idCard == 1">
          <el-form-item
            label="身份证号"
            prop="id_card"
            style="height: 73px"
            :rules="
              configJson.idCard == 1
                ? referInfoRules.id_card
                : [{ required: false }]
            "
          >
            <el-input
              ref="id_card"
              v-model="referForm.id_card"
              placeholder="填写真实身份证号"
              size="small"
              clearable
            />
          </el-form-item>
        </el-col>
        <!-- 手机号 -->
        <el-col :span="12" v-show="configJson.phone == 1">
          <el-form-item
            label="手机号"
            :rules="
              configJson.phone == 1
                ? referInfoRules.phone
                : [{ required: false }]
            "
            style="height: 73px"
          >
            <el-input
              v-model="referForm.phone"
              placeholder="请输入手机号"
              size="small"
              :disabled="true"
            />
          </el-form-item>
        </el-col>
        <!-- 学历 -->
        <el-col :span="12" v-show="configJson.education == 1">
          <el-form-item
            label="学历"
            prop="education"
            style="height: 73px"
            :rules="
              configJson.education == 1
                ? referInfoRules.education
                : [{ required: false }]
            "
          >
            <el-select
              v-model="referForm.education"
              placeholder="请选择学历"
              :popper-append-to-body="false"
              clearable
            >
              <el-option
                v-for="(item, index) in EducationArrs"
                :key="index"
                :label="item"
                :value="item"
              >
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>

        <!-- 单位名称 -->
        <el-col :span="12" v-show="configJson.unitandIdentity == 1">
          <el-form-item
            label="单位名称及身份"
            prop="unit_and_identity"
            style="height: 73px"
            :rules="
              configJson.unitandIdentity == 1
                ? referInfoRules.unit_and_identity
                : [{ required: false }]
            "
          >
            <el-input
              v-model="referForm.unit_and_identity"
              placeholder="请输入单位名称及身份"
              size="small"
            />
          </el-form-item>
        </el-col>
        <!-- 电子邮箱 -->
        <el-col :span="12" v-show="configJson.email == 1">
          <el-form-item
            label="电子邮箱"
            prop="email"
            style="height: 73px"
            :rules="
              configJson.email == 1
                ? referInfoRules.email
                : [{ required: false }]
            "
          >
            <el-input
              v-model="referForm.email"
              placeholder="填写电子邮箱"
              size="small"
            />
          </el-form-item>
        </el-col>
        <!-- 推荐人（非必填） -->
        <el-col :span="12" v-show="configJson.recommend == 1">
          <el-form-item
            label="什么渠道了解的该项目(或推荐人是)?"
            style="height: 73px"
          >
            <el-input
              v-model="referForm.recommend"
              placeholder="填写推荐人或渠道（选填）"
              size="small"
            />
          </el-form-item>
        </el-col>

        <!-- 出生日期 -->
        <el-col :span="12" v-show="configJson.birthday == 1">
          <el-form-item
            label="出生日期"
            prop="birthday"
            :rules="
              configJson.birthday == 1
                ? referInfoRules.birthday
                : [{ required: false }]
            "
          >
            <el-row :gutter="20">
              <el-col :span="8">
                <el-select
                  v-model="bdYear"
                  placeholder="年"
                  :popper-append-to-body="false"
                >
                  <el-option
                    v-for="(item, index) in yearArrs"
                    :key="index"
                    :label="item"
                    :value="item"
                  >
                  </el-option>
                </el-select>
              </el-col>
              <el-col :span="8">
                <el-select
                  v-model="bdMonth"
                  placeholder="月"
                  :popper-append-to-body="false"
                >
                  <el-option
                    v-for="(item, index) in monthArrs"
                    :key="index"
                    :label="item"
                    :value="item"
                  >
                  </el-option>
                </el-select>
              </el-col>
              <el-col :span="8">
                <el-select
                  ref="birthday"
                  v-model="bdDay"
                  placeholder="日"
                  :popper-append-to-body="false"
                  @change="getTime"
                >
                  <el-option
                    v-for="(item, index) in dayArrs"
                    :key="index"
                    :label="item"
                    :value="item"
                  >
                  </el-option>
                </el-select>
              </el-col>
            </el-row>
          </el-form-item>
        </el-col>
        <!-- 籍贯 -->
        <el-col :span="12" v-show="configJson.jiguanCity == 1">
          <el-form-item
            label="籍贯"
            prop="jiguan_code"
            :rules="
              configJson.jiguanCity == 1
                ? referInfoRules.jiguan_code
                : [{ required: false }]
            "
          >
            <el-row :gutter="20">
              <el-col :span="12">
                <!-- @keyup.enter.native="selsectProvince" -->
                <el-select
                  v-model="jgProvinceCode"
                  placeholder="省"
                  :popper-append-to-body="false"
                  @change="changeProvince(1, $event)"
                >
                  <el-option
                    v-for="item in selectProvince"
                    :key="item.id"
                    :label="item.name"
                    :value="item.id"
                  >
                  </el-option>
                </el-select>
              </el-col>
              <el-col :span="12">
                <el-select
                  ref="jiguan_code"
                  v-model="jiguan_city"
                  placeholder="市"
                  :popper-append-to-body="false"
                  @change="getJiguan()"
                >
                  <el-option
                    v-for="item in selectCityJiguan"
                    :key="item.id"
                    :label="item.name"
                    :value="item.id"
                  >
                  </el-option>
                </el-select>
              </el-col>
            </el-row>
          </el-form-item>
        </el-col>
        <!-- 民族 -->
        <el-col :span="12" v-show="configJson.nation == 1">
          <el-form-item
            label="民族"
            prop="nation"
            :rules="
              configJson.nation == 1
                ? referInfoRules.nation
                : [{ required: false }]
            "
          >
            <el-input
              ref="nation"
              v-model="referForm.nation"
              placeholder="填写民族"
              size="small"
              clearable
            />
          </el-form-item>
        </el-col>
        <!-- 入学年份 -->
        <el-col :span="12" v-show="configJson.startSchoolDate == 1">
          <el-form-item
            label="入学年份"
            prop="start_school_date"
            :rules="
              configJson.startSchoolDate == 1
                ? referInfoRules.start_school_date
                : [{ required: false }]
            "
          >
            <el-row :gutter="20">
              <el-col :span="12">
                <el-select
                  v-model="start_grade"
                  placeholder="年级"
                  :popper-append-to-body="false"
                  clearable
                >
                  <el-option
                    v-for="(item, index) in gradeArrs"
                    :key="index"
                    :label="item"
                    :value="item"
                  >
                  </el-option>
                </el-select>
              </el-col>
              <el-col :span="12">
                <el-select
                  ref="start_school_date"
                  v-model="start_year"
                  placeholder="年份"
                  clearable
                  :popper-append-to-body="false"
                  @change="getyear()"
                >
                  <el-option
                    v-for="(item, index) in yearArrs"
                    :key="index"
                    :label="item"
                    :value="item"
                  >
                  </el-option>
                </el-select>
              </el-col>
            </el-row>
          </el-form-item>
        </el-col>
        <!-- 政治面貌 -->
        <el-col :span="12" v-show="configJson.politicalStatus == 1">
          <el-form-item
            label="政治面貌"
            prop="political_status"
            :rules="
              configJson.politicalStatus == 1
                ? referInfoRules.political_status
                : [{ required: false }]
            "
          >
            <el-select
              ref="political_status"
              v-model="referForm.political_status"
              placeholder="填写政治面貌"
              :popper-append-to-body="false"
              clearable
            >
              <el-option
                v-for="item in political_status"
                :key="item.id"
                :label="item.name"
                :value="item.name"
              >
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
      </el-row>
      <!-- 学校信息 -->
      <div
        v-show="
          configJson.school == 1 ||
          configJson.schoolContacts == 1 ||
          configJson.schoolPhone == 1
        "
      >
        <div class="cont_title">学校信息</div>
        <div class="school">
          <el-row :gutter="20">
            <el-col :span="6">
              <el-form-item
                label="就读中学"
                prop="school_province"
                :rules="
                  configJson.school == 1
                    ? referInfoRules.school_province
                    : [{ required: false }]
                "
              >
                <el-select
                  ref="school_province"
                  v-model="referForm.school_province"
                  clearable
                  placeholder="省"
                  :popper-append-to-body="false"
                  @change="changeProvince(2, $event)"
                >
                  <el-option
                    v-for="item in selectProvince"
                    :key="item.id"
                    :label="item.name"
                    :value="item.id"
                  >
                  </el-option>
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item
                class="no_label"
                label=" "
                prop="school_city"
                :rules="
                  configJson.school == 1
                    ? referInfoRules.school_city
                    : [{ required: false }]
                "
              >
                <el-select
                  ref="school_city"
                  v-model="referForm.school_city"
                  clearable
                  placeholder="市"
                  :popper-append-to-body="false"
                  @change="changeCity($event)"
                >
                  <el-option
                    v-for="item in selectCitySchool"
                    :key="item.id"
                    :label="item.name"
                    :value="item.id"
                  >
                  </el-option>
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="12">
              <el-form-item
                class="no_label"
                label=" "
                prop="school"
                :rules="
                  configJson.school == 1
                    ? referInfoRules.school
                    : [{ required: false }]
                "
              >
                <el-select
                  filterable
                  ref="school"
                  v-model="referForm.school"
                  clearable
                  placeholder="中学"
                  :popper-append-to-body="false"
                >
                  <el-option
                    v-for="item in selectSchoolList"
                    :key="item.id"
                    :label="item.name"
                    :value="item.id"
                  >
                  </el-option>
                </el-select>
              </el-form-item>
              <div class="tipsMsg" v-show="$store.state.baseSchool == 1">
                如果没有您所在的学校，请选填其他
              </div>
              <div class="tipsMsg" v-show="$store.state.baseSchool == 0">
                如果没有您所在学校，请联系邮箱：service@campcenter.cn
              </div>
            </el-col>

            <el-col :span="12">
              <el-form-item
                label="中学联系人"
                prop="school_contacts"
                :rules="
                  configJson.schoolContacts == 1
                    ? referInfoRules.school_contacts
                    : [{ required: false }]
                "
              >
                <el-input
                  ref="school_contacts"
                  v-model="referForm.school_contacts"
                  placeholder="填写中学联系人"
                  size="small"
                  clearable
                />
              </el-form-item>
            </el-col>
            <el-col :span="12">
              <el-form-item
                label="中学联系人电话（手机）"
                prop="school_phone"
                :rules="
                  configJson.schoolPhone == 1
                    ? referInfoRules.school_phone
                    : [{ required: false }]
                "
              >
                <el-input
                  ref="school_phone"
                  v-model="referForm.school_phone"
                  placeholder="填写中学联系人电话（手机）"
                  size="small"
                  clearable
                />
              </el-form-item>
            </el-col>
          </el-row>
        </div>
      </div>
      <!-- 学习成绩证明材料 -->
      <div v-show="configJson.achievementPath == 1">
        <div class="cont_title">学习成绩证明材料</div>
        <el-form-item
          label="上传申请资料图片"
          prop="backgroundPicture"
          class="bgPic"
        >
          <div class="bgInfo">
            1、资料包括：近期校级考试的成绩单、在校期间获得证书等相关证明；
          </div>
          <div class="bgInfo">
            2、请上传1-10张图片，支持JPG、JPEG、PNG等格式，每张图片不超过10M
          </div>
          <div class="image_add">
            <div class="image_in">
              <el-upload
                ref="imgUrl"
                name="multipartFile"
                list-type="picture-card"
                :disabled="isUploading || fileList.length >= 10"
                action="#"
                accept=".jpg,.jpeg,.png"
                :limit="10"
                :file-list="fileList"
                :before-upload="beforeAvatarUpload"
                :on-progress="handleUploadProgress"
                :on-success="uploadSuccess"
                :http-request="uploadPicture"
              >
                <i style="font-size: 44px" class="el-icon-circle-plus"> </i>
                <!-- <div class="text">上传材料</div> -->
                <div slot="file" slot-scope="{ file }">
                  <div v-for="(item, idx) in fileList" :key="idx">
                    <img
                      class="el-upload-list__item-thumbnail"
                      :src="file.url"
                      alt=""
                    />
                    <span class="el-upload-list__item-actions">
                      <span
                        class="el-upload-list__item-preview"
                        @click="handlePictureCardPreview(file)"
                      >
                        <i class="el-icon-zoom-in"></i>
                      </span>
                      <span
                        v-if="!disabled"
                        class="el-upload-list__item-delete"
                        @click="handleDownload(file)"
                      >
                        <i class="el-icon-download"></i>
                      </span>
                      <span
                        v-if="!disabled"
                        class="el-upload-list__item-delete"
                        @click="handleRemove(file)"
                      >
                        <i class="el-icon-delete"></i>
                      </span>
                    </span>
                  </div>
                </div>
              </el-upload>
            </div>

            <el-dialog :visible.sync="dialogVisible">
              <img width="100%" :src="resultPicture" alt="" />
            </el-dialog>
          </div>
        </el-form-item>
      </div>

      <el-form-item class="btn">
        <el-button @click="confirm">提交资料</el-button>
      </el-form-item>
    </el-form>
  </div>
</template>

<script>
/* eslint-disable */
import Cookie from "js-cookie";
import {
  getAccount,
  getAchievementOss,
  delPic,
  setAccount,
  getProAndCity,
  getSchool,
} from "r/index/signUp";
import { upload } from "r/index/network";
import validator from "common/validator";
import area from "config/area";

export default {
  name: "referInfo",

  data() {
    const validateContent = (rule, value, callback) => {
      if (!this.referForm.birthday) {
        callback(new Error("出生日期不能为空！"));
      } else {
        callback();
      }
    };
    const validateContents = (rule, value, callback) => {
      if (!this.referForm.jiguan_code) {
        callback(new Error("籍贯不能为空！"));
      } else {
        callback();
      }
    };
    return {
      configJson: {},
      isUploading: false, // 图片上传蒙层
      referForm: {
        name: null,
        gender: null,
        age: null,
        id_card: null,
        education: null,
        birthday: null,
        jiguan_code: null,
        address: null,
        country: null,
        nation: null,
        start_school_date: null,
        political_status: null,
        phone: null,
        unit_and_identity: null,
        email: null,
        recommend: null,
        school_province: null,
        school_city: null,
        school: null,
        school_contacts: null,
        school_phone: null,
      },

      schoolName: {},
      referInfoRules: {
        name: [{ required: true, message: "姓名不能为空！", trigger: "blur" }],
        gender: [
          { required: true, message: "性别不能为空！", trigger: "change" },
        ],

        id_card: [
          { required: true, message: "身份证号不能为空！", trigger: "blur" },
          { validator: validator.validateid_card, trigger: "blur" },
        ],
        birthday: [
          {
            required: true,
            validator: validateContent,
            trigger: "change",
          },
        ],

        jiguan_code: [
          { required: true, validator: validateContents, trigger: "change" },
        ],

        nation: [
          { required: true, message: "民族不能为空！", trigger: "change" },
        ],
        country: [
          { required: true, message: "国籍不能为空！", trigger: "change" },
        ],
        start_school_date: [
          {
            required: true,
            message: "入学年份不能为空！",
            trigger: "change",
          },
        ],
        political_status: [
          { required: true, message: "政治面貌不能为空！", trigger: "blur" },
        ],
        email: [
          { required: true, message: "电子邮箱不能为空！", trigger: "blur" },
          { validator: validator.validateEmail, trigger: "blur" },
        ],
        age: [
          { required: true, message: "年龄不能为空！", trigger: "blur" },
          { validator: validator.validateNumber, trigger: "blur" },
        ],
        education: [
          { required: true, message: "学历不能为空！", trigger: "change" },
        ],

        // address: [
        //   { required: true, message: "详细地址不能为空！", trigger: "blur" },
        // ],

        unit_and_identity: [
          {
            required: true,
            message: "单位名称及身份不能为空！",
            trigger: "blur",
          },
        ],

        school_province: [
          {
            required: true,
            message: "请选择所在学校省份！",
            trigger: "change",
          },
        ],
        school_city: [
          {
            required: true,
            message: "请选择所在学校城市！",
            trigger: "change",
          },
        ],
        school: [
          { required: true, message: "请选择所在学校！", trigger: "change" },
        ],
        school_contacts: [
          { required: true, message: "请填写中学联系人！", trigger: "blur" },
        ],
        school_phone: [
          {
            required: true,
            message: "中学联系人电话（手机）不能为空！",
            trigger: "blur",
          },
          { validator: validator.validatePhone, trigger: "blur" },
        ],

        // backgroundPicture: [{ required: true, message: "请上传图片" }],
      },

      EducationArrs: ["初中", "高中", "大学", "硕士", "博士"],
      countryList: area.country, //国籍
      selectProvince: [], //省份
      CityName: {}, //根据省份筛选出所有城市的对象
      selectCityJiguan: [], //籍贯城市列表
      selectCitySchool: [], //就读中学-城市列表
      selectSchoolList: [], //就读中学-中学列表
      jgProvinceCode: "", //省份id
      jiguan_city: "", //城市id(和省份id拼接)
      yearArrs: [], //生日涉及的近10年的年份

      monthArrs: [
        "01",
        "02",
        "03",
        "04",
        "05",
        "06",
        "07",
        "08",
        "09",
        "10",
        "11",
        "12",
      ],
      dayArrs: [
        "01",
        "02",
        "03",
        "04",
        "05",
        "06",
        "07",
        "08",
        "09",
        "10",
        "11",
        "12",
        "13",
        "14",
        "15",
        "16",
        "17",
        "18",
        "19",
        "20",
        "21",
        "22",
        "23",
        "24",
        "25",
        "26",
        "27",
        "28",
        "29",
        "30",
        "31",
      ],
      bdYear: "", //选择的生日年份
      bdMonth: "", //选择的生日月份
      bdDay: "", //选择的生日日期
      //入学年份（初中高中）
      gradeArrs: ["初中", "高中", "大学"],
      //选择年级
      start_grade: "",
      start_year: "",
      // 政治面貌
      political_status: [
        {
          id: 1,
          name: "党员",
        },
        {
          id: 2,
          name: "团员",
        },
        {
          id: 3,
          name: "群众",
        },
      ],
      // 中学（模糊搜索）
      // timeout: null,
      // school: "",
      // 上传的图片
      dialogImageUrl: "",
      dialogVisible: false,
      fileList: [],
      resultPicture: "",
      dialogVisible: false,
      disabled: false, //限制输入框
    };
  },
  created() {
    const code = this.$store.state.indexIdentity;
    this.referForm.phone = window.localStorage.getItem("phone" + code); //本地取用户手机号
    this.referForm.email = window.localStorage.getItem("email" + code); //本地取用户邮箱
    // console.log(this.referForm.email, " this.referForm.email");
    let signUpFile = window.localStorage.getItem(
      "sign_up_file_" + window.localStorage.getItem("phone" + code) + code
    );
    // console.log(signUpFile);
    if (signUpFile && JSON.parse(signUpFile).length > 0) {
      this.fileList = JSON.parse(signUpFile);
    }
    this.getSchool();
    this.getProAndCity();
    this.getTenYear();
    this.getAccount(); // 页面信息个人获取
    this.configJson = this.$store.state.configJson;
  },
  watch: {
    referForm(val) {
      // console.log(val, "val");
      for (var k in val) {
        if (val[k] == null || !val[k]) {
          val[k] = this.referForm[k];
        }
      }
      this.selfInfo = val;
      if (val.gender && val.gender !== "") {
        // console.log(val.gender)
        this.referForm.gender = val.gender;
      }
      //出生日期
      if (val.birthday && val.birthday !== "") {
        this.bdYear = val.birthday.slice(0, 4); //前4位取年
        this.bdMonth = val.birthday.slice(4, 6); //中2位取月
        this.bdDay = val.birthday.slice(6, 8); //后2位取日
      }
      //入学年份
      if (val.start_school_date && val.start_school_date !== "") {
        this.start_year = val.start_school_date.slice(0, 4); //年份
        this.start_grade = val.start_school_date.slice(5, 8); //年级
      }
      //籍贯
      if (val.jiguan_city !== null && val.jiguan_province !== null) {
        if (this.referForm.jiguan_city) {
        }
        this.jgProvinceCode = Number(val.jiguan_province);
        this.changeProvince(1, this.jgProvinceCode, true);
        this.jiguan_city = Number(val.jiguan_city);
      }
      // console.log(val.school_province, val.school_city, val.school);
      //学校
      if (
        val.school_province !== null &&
        val.school_city !== null &&
        val.school !== null
      ) {
        this.referForm.school_province = Number(val.school_province);
        this.referForm.school_city = Number(val.school_city);
        this.referForm.school = Number(val.school);
        // console.log(
        //   this.referForm.school_province,
        //   this.referForm.school_city,
        //   this.referForm.school
        // );
        this.changeProvince(2, this.referForm.school_province, true);
        // console.log(this.referForm.school_city, 12322);
        this.changeCity(this.referForm.school_city, true);
        // console.log(this.referForm.school_city, 12322);
      }
    },
  },
  mounted() {},
  methods: {
    // 页面信息个人获取
    getAccount() {
      getAccount({}).then((res) => {
        // console.log(res, "getAccount");
        if (res.data.code != 200) {
          return this.$message.error(res.data.message);
        }
        this.referForm = res.data.info;
        if (res.data.info.jiguan_province && res.data.info.jiguan_city) {
          this.referForm.jiguan_code =
            res.data.info.jiguan_province.toString() +
            res.data.info.jiguan_city.toString();
        }
        if (res.data.info.email == null) {
          const code = this.$store.state.indexIdentity;
          this.referForm.email = window.localStorage.getItem("email" + code); //本地取用户邮箱
        }
      });
    },
    //获取近10年的年份
    getTenYear() {
      let nowDate = new Date();
      let currentYear = nowDate.getFullYear();
      // console.log(nowDate, currentYear);
      let yearArr = [];
      let rxYearArr = [];
      for (let i = 0; i < 73; i++) {
        let year = currentYear - i;
        yearArr.push(year);
      }
      console.log(yearArr, "yearArr");
      this.yearArrs = yearArr;
    },

    //组装出生日期
    getTime() {
      this.referForm.birthday =
        this.bdYear.toString() +
        this.bdMonth.toString() +
        this.bdDay.toString();
      // console.log(this.referForm.birthday);
    },
    // 国籍

    //组装入学年份
    getyear() {
      this.referForm.start_school_date =
        this.start_year.toString() + "-" + this.start_grade.toString();
    },
    // 获取省份城市
    getProAndCity() {
      getProAndCity({}).then((res) => {
        // console.log(res, "getProAndCity");
        if (res.data.code != 200) {
          return this.$message.error(res.data.message);
        }
        this.selectProvince = res.data.province_list;
        // this.CityName = res.data.city_list;
        // console.log(this.selectProvince, this.CityName);
      });
    },

    //选择籍贯省份change事件
    changeProvince(type, val, status) {
      // console.log(type, val);
      if (type == 1) {
        this.selectCityJiguan = [];
        this.selectCityJiguan = this.getCurrentCityLists(val);
        if (!status) {
          this.jiguan_city = "";
          this.referForm.jiguan_code = "";
        }
      } else {
        this.selectCitySchool = [];
        this.selectCitySchool = this.getCurrentCityLists(val); //在此调用城市筛选列表
        if (!status) {
          this.referForm.school_city = "";
          this.referForm.school = "";
          this.selectSchoolList = []; //重新选择省份时候，学校list清空
        }
      }
    },

    //返回当前省份下的城市列表
    getCurrentCityLists(val) {
      let currentCity = [];
      if (
        this.CityName == null ||
        !this.CityName ||
        Object.values(this.CityName).length == 0
      ) {
        getProAndCity({})
          .then((res) => {
            // console.log(res, "getProAndCity");
            if (res.data.code === 200) {
              // this.selectProvince = res.data.province_list;
              this.CityName = res.data.city_list;

              for (let key in this.CityName) {
                if (this.CityName[key].parent_id == val) {
                  currentCity.push(this.CityName[key]);
                }
              }
              return currentCity;
            } else {
              this.$message.error(res.data.message);
            }
          })
          .catch((err) => {
            this.$message.error(err);
          });
      } else {
        for (let key in this.CityName) {
          if (this.CityName[key].parent_id == val) {
            currentCity.push(this.CityName[key]);
          }
        }
        return currentCity;
      }
      return currentCity;
    },

    // 籍贯城市change事件
    getJiguan() {
      this.referForm.jiguan_code =
        this.jgProvinceCode.toString() + this.jiguan_city.toString();
    },
    getSchool() {
      getSchool({}).then((res) => {
        // console.log(res, "getSchool");
        if (res.data.code != 200) {
          return this.$message.error(res.data.message);
        }
        this.schoolName = res.data.school_list;
      });
    },
    // 学校城市change事件
    changeCity(val, status) {
      // console.log(12345333,val,status)
      this.selectSchoolList = [];
      this.selectSchoolList = this.getCurrentSchoolLists(val);
      console.log(this.selectSchoolList, "selectSchoolList");
      if (!status) {
        this.referForm.school = "";
      }
      // let data = this.selectSchoolList.map((item) => {
      //   return {
      //     name: item.id,
      //     value: item.name,
      //   };
      // });
      // this.restaurants = data; //中学（模糊搜索）
    },

    // 返回当前城市下的学校列表
    getCurrentSchoolLists(val) {
      let currentSchool = [];
      let baseSchool = this.$store.state.baseSchool;
      if (baseSchool && baseSchool == 1) {
        currentSchool.unshift({
          id: 0,
          name: "其他",
        });
      }
      // console.log(this.schoolName);
      if (
        this.schoolName == null ||
        !this.schoolName ||
        Object.values(this.schoolName).length == 0
      ) {
        getSchool({})
          .then((res) => {
            // console.log(res)
            if (res.data.code === 200) {
              this.schoolName = res.data.school_list;
              //  console.log( this.schoolName)
              let code = this.$store.state.indexIdentity;
              window.localStorage.setItem(
                "schoolName" + code,
                JSON.stringify(res.data.list)
              );

              for (let key in this.schoolName) {
                if (this.schoolName[key].city_id == val) {
                  currentSchool.push(this.schoolName[key]);
                  console.log(currentSchool, "currentSchool");
                }
              }
              return currentSchool;
            } else {
              this.$message.error(res.data.message);
            }
          })
          .catch((err) => {
            this.$message.error(err);
          });
      } else {
        // console.log(this.schoolName, 111);
        for (let key in this.schoolName) {
          // console.log(key, this.schoolName[key]);
          if (this.schoolName[key].city_id == val) {
            currentSchool.push(this.schoolName[key]);
          }
        }
        // console.log(currentSchool, 222);
        return currentSchool;
      }
      return currentSchool;
    },

    // 图片上传成功前钩子
    beforeAvatarUpload(file) {
      // console.log(file, "beforeImage");
      const isJPG = file.type === "image/jpg";
      const isPng = file.type === "image/png";
      const isJPEG = file.type === "image/jpeg";
      const isLt10M = file.size / 1024 / 1024 < 10;
      //  console.log(isLt10M)
      if (!isJPG && !isPng && !isJPEG) {
        this.$message.info("上传图片只能是 JPG,JPEG或png 格式!");
      }
      if (!isLt10M) {
        this.$message.info("上传图片大小不能超过 10MB!");
      }
      return (isJPG || isPng || isJPEG) && isLt10M;
    },

    handlePictureCardPreview(file) {
      console.log(file, "11111111");
      this.resultPicture = file.url;
      this.dialogVisible = true;
    },
    // 文件上传中处理
    handleUploadProgress(event, file, fileList) {
      // console.log(fileList);
      this.isUploading = true;
      if (this.fileList.lenge < 10) {
        return this.$message.info("chaochushuliamng");
      }
    },
    uploadSuccess(res, file, fileList) {
      // console.log(res, "res");
      // console.log(file, "file");
      // console.log(fileList, "fileList");
      this.referForm.achievementPath = res;
      this.fileList = {
        name: file.name,
        url: res,
      };
      this.$refs["imgUrl"].clearFiles(); //上传成功之后清除历史记录
    },
    uploadPicture(params) {
      // console.log("已经准备好上传图片", params);
      this.file = params.file;
      let raw = params.file;
      let image = {
        name: raw.name,
        size: raw.size,
        type: raw.type,
      };
      this.getOssConfigs(image, params.file);
    },
    async getOssConfigs(image, file) {
      let obj = {
        url: "",
        savefile: "",
      };
      await getAchievementOss({ image: image })
        .then((res) => {
          // console.log(res, "开始上传图片");
          if (res.data.code === 200) {
            let oss_url = res.data.config.host;
            let filename = res.data.config.file;
            let formData = new FormData();
            formData.append("OSSAccessKeyId", res.data.config.accessid);
            formData.append("policy", res.data.config.policy);
            formData.append("signature", res.data.config.signature);
            formData.append("filename", res.data.config.file);
            formData.append("key", res.data.config.savefile);
            formData.append("callback", res.data.config.callback);
            formData.append("success_action_status", 200);
            formData.append("file", file);
            // console.log(formData);
            upload(oss_url, formData)
              .then((ress) => {
                // console.log(ress, "ress");
                if (ress.data.code != 200) {
                  console.log(ress, "ress");
                  return this.$message.error(ress.data.message);
                }
                this.resultPicture = filename + "?t=" + Date.parse(new Date());
                this.$forceUpdate();
                this.$message.success("上传成功");
                obj = {
                  url: ress.data.picture_path,
                  savefile: res.data.config.savefile,
                };
                this.fileList.push(obj);
                let code = this.$store.state.indexIdentity;
                window.localStorage.setItem(
                  "sign_up_file_" +
                    +window.localStorage.getItem("phone" + code) +
                    code,
                  JSON.stringify(this.fileList)
                );
              })
              .catch((err) => {
                this.$message.error(err);
              });
          } else {
            this.$message.error(res.data.message);
          }
        })
        .catch((err) => {
          // console.log(err);
        });
    },
    // 下载证明资料图片
    handleDownload(file) {
      // console.log(file,'file22');
      window.location.href = file.url;
    },
    //删除图片
    handleRemove(file) {
      // console.log(file, "file");
      this.$confirm("此操作将永久删除该文件, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          let getfile = file.url;
          // console.log(savefile.match(/^(?:[^\/]|\/\/)*/),'222222')；//获取域名
          let str = getfile.split(
            "https://yingdi-achievement.oss-cn-beijing.aliyuncs.com/"
          ); //https://yingdi-achievement.oss-cn-beijing.aliyuncs.com/进行分割，
          // console.log(str, "str");
          let savefile = str[1];
          // console.log(savefile, "savefile");
          delPic({ object: savefile }).then((res) => {
            // console.log(res, "delpic");
            if (res.data.code != 200) {
              return this.$message.error(res.data.message);
            }
            this.fileList.forEach((item, idx) => {
              // console.log(item.url == file.url);
              if (item.url == file.url) {
                this.fileList.splice(idx, 1);
                let code = this.$store.state.indexIdentity;
                window.localStorage.setItem(
                  "sign_up_file_" +
                    window.localStorage.getItem("phone" + code) +
                    code,
                  JSON.stringify(this.fileList)
                );
              }
            });
            // console.log(this.fileList);
            this.$message.success(res.data.message);
          });
        })
        .catch((err) => {
          this.$message({
            type: "info",
            message: "取消删除",
          });
        });
    },
    // 滚动到固定地方
    scrollView(object) {
      // console.log(object, "object");
      for (let i in object) {
        if (!i) {
          continue;
        }
        let dom = this.$refs[i];
        // console.log(i, dom);
        if (!dom) {
          continue;
        }
        // 这里是针对遍历的情况（多个输入框），取值为数组
        if (Object.prototype.toString.call(dom) !== "[object Object]") {
          dom = dom[0];
        }
        // 第一种方法（包含动画效果）
        dom.$el.scrollIntoView({
          // 滚动到指定节点
          // 值有start,center,end，nearest，当前显示在视图区域中间
          block: "center",
          // 值有auto、instant,smooth，缓动动画（当前是慢速的）
          behavior: "smooth",
        });
        break; // 因为我们只需要检测一项,所以就可以跳出循环了
      }
    },
    confirm() {
      // console.log(111);
      // console.log(this.referForm.birthday);
      this.$refs["referRef"].validate((valid, object) => {
        // console.log(valid, "valid");
        if (!valid) {
          this.scrollView(object);
          return false;
        }

        let _this = this;
        let obj = {};
        if (this.configJson.name == 1) {
          obj.name = _this.referForm.name;
        }
        if (this.configJson.gender == 1) {
          obj.gender = _this.referForm.gender;
        }
        if (this.configJson.idCard == 1) {
          obj.id_card = _this.referForm.id_card;
        }
        if (this.configJson.age == 1) {
          obj.age = _this.referForm.age;
        }
        if (this.configJson.education == 1) {
          obj.education = _this.referForm.education;
        }

        if (this.configJson.postAddress == 1) {
          obj.address = _this.referForm.address;
        }
        if (this.configJson.country == 1) {
          obj.country = _this.referForm.country;
        }
        if (this.configJson.nation == 1) {
          obj.nation = _this.referForm.nation;
        }
        if (this.configJson.phone == 1) {
          obj.phone = _this.referForm.phone;
        }
        if (this.configJson.unitandIdentity == 1) {
          obj.unit_and_identity = _this.referForm.companyName;
        }
        if (this.configJson.email == 1) {
          obj.email = _this.referForm.email;
        }
        if (this.configJson.jiguanCity == 1) {
          obj.jiguan_code = _this.referForm.jiguan_code;
        }
        if (this.configJson.recommend == 1) {
          obj.recommend = _this.referForm.recommend;
        }
        if (this.configJson.recommend == 1) {
          obj.start_school_date = _this.referForm.start_school_date;
        }
        if (this.configJson.birthday == 1) {
          obj.birthday = _this.referForm.birthday;
        }
        if (this.configJson.school == 1) {
          obj.school_province = _this.referForm.school_province;
          obj.school_city = _this.referForm.school_city;
          obj.school = _this.referForm.school;
        }
        if (this.configJson.schoolContacts == 1) {
          obj.school_contacts = _this.referForm.school_contacts;
        }
        if (this.configJson.schoolPhone == 1) {
          obj.school_phone = _this.referForm.school_phone;
        }
        setAccount(obj).then((res) => {
          // console.log(res, "setAccount");
          if (res.data.code != 200) {
            if (res.data.code == 400068) {
              this.$parent.statuss();
              return this.$message.error(res.data.message);
            }
            return this.$message.error(res.data.message);
          }
          // console.log(3333);
          this.$emit("getstatus", res.data.status);
          this.$message.success(res.data.message);
          // let code = this.$store.state.indexIdentity;
          // this.$router.push("/signUp/check?code=" + code);
          this.referForm = res.data.data;
        });
      });
    },
  },
};
</script>

<style scoped lang="scss">
@import "a/scss/btn";
@import "a/scss/SignUp/referInfo";
</style>
